<template>
  <div id="app" class="small-container">
    <h1>My Contacts</h1>
    <contact-form @add:contact="addContact" />
    <contact-table
      :contacts="contacts"
      @delete:contact="deleteContact"
      @edit:contact="editContact"
    />
  </div>
</template>

<script>
import contactTable from "./components/ContactTable.vue";
import contactForm from "./components/ContactForm.vue";
export default {
  name: "app",
  components: {
    contactTable,
    contactForm
  },
  data() {
    return {
      contacts: []
    };
  },
  mounted() {
    this.getContacts();
  },
  methods: {
    async getContacts() {
      try {
        const response = await fetch("http://localhost:3000/users", {
          headers: {
            "Content-Type": "application/json"
          }
        });
        const data = await response.json();
        this.contacts = data;
        // console.log(data);
      } catch (error) {
        console.error(error);
      }
    },
    async addContact(contact) {
      try {
        const response = await fetch("http://localhost:3000/users", {
          headers: {
            "Content-Type": "application/json"
          },
          method: "POST",
          // format the data
          body: JSON.stringify(contact)
        });

        const new_contact = await response.json();
        /* console.log(new_contact); */
        this.contacts = [...this.contacts, new_contact];
      } catch (error) {
        console.error(error);
      }
    },
    async editContact(id, updatedcontact) {
      try {
        const response = await fetch(`http://localhost:3000/users/${id}`, {
          method: "PUT",
          body: JSON.stringify(updatedcontact),
          headers: { "Content-type": "application/json; charset=UTF-8" }
        });
        const data = await response.json();
        this.contacts = this.contacts.map(contact =>
          contact.id === id ? data : contact
        );
      } catch (error) {
        console.error(error);
      }
    },
    async deleteContact(id) {
      try {
        await fetch(`http://localhost:3000/users/${id}`, {
          method: "DELETE"
        });
        this.contacts = this.contacts.filter(contact => contact.id !== id);
      } catch (error) {
        console.error(error);
      }
    }
  }
};
</script>

<style>
h1 {
  text-align: center
}

button {
  background: #006c7f;
  border: 1px solid #006c7f;
}

.small-container {
  max-width: 680px;
}
</style>
